%%%
%% jcej.cls (LaTeX2e Class File)
%%   for the Journal of Chemical Engineering of Japan
%%     by Motoaki Sato (ULS and Company), 2011.
%% E-mail: teppei@uls.co.jp, http://www.uls.co.jp/
\NeedsTeXFormat{LaTeX2e}[1995/12/01]
\ProvidesClass{jcej}
%% based on [2004/02/16 v1.4f Standard LaTeX document class]
  [2011/01/31 v1.00-RC1 for JCEJ]

\def\jcej@warning{\ClassWarningNoLine{jcej}}
\def\jcejline@warning{\ClassWarning{jcej}}

\newif\if@Proof \@Prooffalse
\DeclareOption{Proof}{\@Prooftrue}

%\newif\if@cameraready \@camerareadyfalse
%\DeclareOption{cameraready}{\@camerareadytrue}

\DeclareOption{ResearchPaper}{\gdef\jcej@type{Research Paper}}
\DeclareOption{SC}{\gdef\jcej@type{Short Communication}}
\DeclareOption{letter}{\gdef\jcej@type{Letter to the Editor}}
\DeclareOption{journal}{\gdef\jcej@type{Journal Review}}
\DeclareOption{editorial}{\gdef\jcej@type{Editorial Note}}
\def\jcej@type{Research Paper}

\@ifundefined{@needsPformat}{}{%
 \newif\if@enablejfam \@enablejfamtrue
 \DeclareOption{disablejfam}{\@enablejfamfalse}%
 \newif\if@mathrmmc \@mathrmmcfalse
}

\newcommand\@ptsize{}
%\newif\if@restonecol
%\newif\if@titlepage
%\@titlepagefalse
\DeclareOption{a4paper}%
   {\setlength\paperheight {297mm}% 285mm
    \setlength\paperwidth  {210mm}}
\DeclareOption{10pt}{\renewcommand\@ptsize{0}}
\DeclareOption{11pt}{\renewcommand\@ptsize{1}}
\DeclareOption{12pt}{\renewcommand\@ptsize{2}}
\DeclareOption{oneside}{\@twosidefalse \@mparswitchfalse}
\DeclareOption{twoside}{\@twosidetrue  \@mparswitchtrue}
\DeclareOption{draft}{\setlength\overfullrule{5pt}}
\DeclareOption{final}{\setlength\overfullrule{0pt}}
%\DeclareOption{titlepage}{\@titlepagetrue}
%\DeclareOption{notitlepage}{\@titlepagefalse}
\DeclareOption{onecolumn}{\@twocolumnfalse}
\DeclareOption{twocolumn}{\@twocolumntrue}
\DeclareOption{leqno}{\input{leqno.clo}}
\DeclareOption{fleqn}{%\input{fleqn.clo}
 \AtBeginDocument{%
  \jcej@warning{fleqn option is incorporated into this class file}}}
\DeclareOption{openbib}{%
  \AtEndOfPackage{%
   \renewcommand\@openbib@code{%
      \advance\leftmargin\bibindent
      \itemindent -\bibindent
      \listparindent \itemindent
      \parsep \z@
      }%
   \renewcommand\newblock{\par}}%
}
\ExecuteOptions{a4paper,10pt,oneside,twoside,twocolumn,final}
\ProcessOptions

\@ifundefined{@needsPformat}{}{% for japanese pLaTeX
 \DeclareFontShape{JY1}{mc}{m}{it}{<->ssub*mc/m/n}{}
 \DeclareFontShape{JY1}{gt}{m}{it}{<->ssub*gt/m/n}{}
 \DeclareFontShape{JY1}{mc}{bx}{it}{<->ssub*mc/bx/n}{}
 \DeclareFontShape{JY1}{gt}{bx}{it}{<->ssub*gt/m/n}{}
 \DeclareFontShape{JY1}{mc}{m}{sc}{<->ssub*mc/m/n}{}
 \DeclareFontShape{JY1}{gt}{m}{sc}{<->ssub*gt/m/n}{}
 \DeclareFontShape{JY1}{mc}{bx}{sc}{<->ssub*mc/bx/n}{}
 \DeclareFontShape{JY1}{gt}{bx}{sc}{<->ssub*gt/m/n}{}
 \DeclareFontShape{JY1}{mc}{m}{sl}{<->ssub*mc/m/n}{}
 \DeclareFontShape{JY1}{gt}{m}{sl}{<->ssub*gt/m/n}{}
 \DeclareFontShape{JY1}{mc}{bx}{sl}{<->ssub*mc/bx/n}{}
 \DeclareFontShape{JY1}{gt}{bx}{sl}{<->ssub*gt/m/n}{}
 \DeclareFontShape{JT1}{mc}{m}{it}{<->ssub*mc/m/n}{}
 \DeclareFontShape{JT1}{gt}{m}{it}{<->ssub*gt/m/n}{}
 \DeclareFontShape{JT1}{mc}{bx}{it}{<->ssub*mc/bx/n}{}
 \DeclareFontShape{JT1}{gt}{bx}{it}{<->ssub*gt/m/n}{}
 \DeclareFontShape{JT1}{mc}{m}{sc}{<->ssub*mc/m/n}{}
 \DeclareFontShape{JT1}{gt}{m}{sc}{<->ssub*gt/m/n}{}
 \DeclareFontShape{JT1}{mc}{bx}{sc}{<->ssub*mc/bx/n}{}
 \DeclareFontShape{JT1}{gt}{bx}{sc}{<->ssub*gt/m/n}{}
 \DeclareFontShape{JT1}{mc}{m}{sl}{<->ssub*mc/m/n}{}
 \DeclareFontShape{JT1}{gt}{m}{sl}{<->ssub*gt/m/n}{}
 \DeclareFontShape{JT1}{mc}{bx}{sl}{<->ssub*mc/bx/n}{}
 \DeclareFontShape{JT1}{gt}{bx}{sl}{<->ssub*gt/m/n}{}
}

%% <\input{size1\@ptsize.clo}>
\renewcommand\normalsize{%
 \@setfontsize\normalsize\@xpt\@xiipt
 %\abovedisplayskip 10\p@ \@plus2\p@ \@minus5\p@
 %\abovedisplayshortskip \z@ \@plus3\p@
 %\belowdisplayshortskip 6\p@ \@plus3\p@ \@minus3\p@
 \abovedisplayskip .5\baselineskip
  \@plus .25\baselineskip \@minus .15\baselineskip
 \abovedisplayshortskip \z@ \@plus 1\p@
 \belowdisplayshortskip .3\baselineskip
  \@plus .15\baselineskip \@minus .1\baselineskip
 \belowdisplayskip \abovedisplayskip
 \let\@listi\@listI}

\normalsize

\newcommand\small{%
 \@setfontsize\small\@ixpt{11}%
 %\abovedisplayskip 8.5\p@ \@plus3\p@ \@minus4\p@
 %\abovedisplayshortskip \z@ \@plus2\p@
 %\belowdisplayshortskip 4\p@ \@plus2\p@ \@minus2\p@
 \abovedisplayskip .5\baselineskip
  \@plus .25\baselineskip \@minus .15\baselineskip
 \abovedisplayshortskip \z@ \@plus 1\p@
 \belowdisplayshortskip .3\baselineskip
  \@plus .15\baselineskip \@minus .1\baselineskip
 \belowdisplayskip \abovedisplayskip
 \def\@listi{\leftmargin\leftmargini
             \topsep .5\baselineskip
              \@plus .25\baselineskip \@minus .15\baselineskip
             \parsep \z@\partopsep\z@
             \itemsep \parsep}%
}

\newcommand\footnotesize{%
 \@setfontsize\footnotesize\@viiipt{10}%
 %\abovedisplayskip 6\p@ \@plus2\p@ \@minus4\p@
 %\abovedisplayshortskip \z@ \@plus\p@
 %\belowdisplayshortskip 3\p@ \@plus\p@ \@minus2\p@
 \abovedisplayskip .5\baselineskip
  \@plus .25\baselineskip \@minus .15\baselineskip
 \abovedisplayshortskip \z@ \@plus 1\p@
 \belowdisplayshortskip .3\baselineskip
  \@plus .15\baselineskip \@minus .1\baselineskip
 \belowdisplayskip \abovedisplayskip
 \def\@listi{\leftmargin\leftmargini
             \topsep .5\baselineskip
              \@plus .25\baselineskip \@minus .15\baselineskip
             \parsep \z@\partopsep\z@
             \itemsep \parsep}%
}

\newcommand\scriptsize{\@setfontsize\scriptsize\@viipt\@viiipt}
\newcommand\tiny{\@setfontsize\tiny\@vpt\@vipt}
\newcommand\large{\@setfontsize\large\@xiipt{14}}
\newcommand\Large{\@setfontsize\Large\@xivpt{18}}
%\newcommand\LARGE{\@setfontsize\LARGE\@xviipt{22}}
\newcommand\LARGE{\@setfontsize\LARGE{16pt}{18}}
\newcommand\huge{\@setfontsize\huge\@xxpt{25}}
\newcommand\Huge{\@setfontsize\Huge\@xxvpt{30}}

\setlength\parindent{20pt}
\newdimen\save@parindent \save@parindent\parindent

\setlength\smallskipamount{3\p@ \@plus 1\p@ \@minus 1\p@}
\setlength\medskipamount{6\p@ \@plus 2\p@ \@minus 2\p@}
\setlength\bigskipamount{12\p@ \@plus 4\p@ \@minus 4\p@}

\setlength\headheight{9.5\p@}
\setlength\headsep   {2mm}
\setlength\topskip   {10\p@}
\setlength\footskip{26\p@}% 27
\setlength\maxdepth{.5\topskip}

\textwidth480pt
%\@settopoint\textwidth
\textheight 56\baselineskip
\advance \textheight \topskip
%\advance \textheight .15mm

\if@twocolumn
 \setlength\marginparsep {10\p@}
\else
  \setlength\marginparsep{11\p@}
\fi
\setlength\marginparpush{5\p@}

\setlength\@tempdima        {\paperwidth}
\addtolength\@tempdima      {-\textwidth}
\setlength\oddsidemargin    {.4\@tempdima}
\addtolength\oddsidemargin  {-1in}
\setlength\marginparwidth   {.6\@tempdima}
\addtolength\marginparwidth {-\marginparsep}
\addtolength\marginparwidth {-0.4in}
\ifdim \marginparwidth >2in
 \setlength\marginparwidth{2in}
\fi

\topmargin\paperheight
\advance \topmargin -\textheight
\advance \topmargin -\headheight
\advance \topmargin -\headsep
\advance \topmargin -\footskip
\divide \topmargin \tw@
%%\advance \topmargin % 297/285
%\if@cameraready\else
 \advance \topmargin -1in
%\fi
%\@settopoint\topmargin
\oddsidemargin\paperwidth
\advance \oddsidemargin -\textwidth
\divide \oddsidemargin \tw@
%\if@cameraready\else
 \advance \oddsidemargin -1in
%\fi
%\@settopoint\oddsidemargin
\evensidemargin\oddsidemargin
%\@settopoint\evensidemargin

\footnotesep7\p@
\skip\footins .75\baselineskip \@plus .25\baselineskip \@minus .25\baselineskip
\floatsep 1.5\baselineskip \@plus 2\p@ \@minus 2\p@
\textfloatsep 2\baselineskip \@plus 2\p@ \@minus 4\p@
\intextsep 2\baselineskip \@plus 2\p@ \@minus 2\p@
\dblfloatsep 1.5\baselineskip \@plus 2\p@ \@minus 2\p@
\dbltextfloatsep 2\baselineskip \@plus 2\p@ \@minus 4\p@

\setlength\@fptop{0\p@ \@plus 1fil}
\setlength\@fpsep{8\p@ \@plus 2fil}
\setlength\@fpbot{0\p@ \@plus 1fil}
\setlength\@dblfptop{0\p@ \@plus 1fil}
\setlength\@dblfpsep{8\p@ \@plus 2fil}
\setlength\@dblfpbot{0\p@ \@plus 1fil}
\setlength\partopsep{2\p@ \@plus 1\p@ \@minus 1\p@}

\def\@listi{\leftmargin\leftmargini
 \topsep .5\baselineskip \@plus .25\baselineskip \@minus .15\baselineskip
 \parsep\z@\itemsep\z@\partopsep\z@
 %\parsep 4\p@ \@plus2\p@ \@minus\p@
 %\topsep 8\p@ \@plus2\p@ \@minus4\p@
 %\itemsep4\p@ \@plus2\p@ \@minus\p@
}
\let\@listI\@listi
\@listi
\def\@listii {\leftmargin\leftmarginii
              \labelwidth\leftmarginii
              \advance\labelwidth-\labelsep
              \topsep    4\p@ \@plus2\p@ \@minus\p@
              \parsep    2\p@ \@plus\p@  \@minus\p@
              \itemsep   \parsep}
\def\@listiii{\leftmargin\leftmarginiii
              \labelwidth\leftmarginiii
              \advance\labelwidth-\labelsep
              \topsep    2\p@ \@plus\p@\@minus\p@
              \parsep    \z@
              \partopsep \p@ \@plus\z@ \@minus\p@
              \itemsep   \topsep}
\def\@listiv {\leftmargin\leftmarginiv
              \labelwidth\leftmarginiv
              \advance\labelwidth-\labelsep}
\def\@listv  {\leftmargin\leftmarginv
              \labelwidth\leftmarginv
              \advance\labelwidth-\labelsep}
\def\@listvi {\leftmargin\leftmarginvi
              \labelwidth\leftmarginvi
              \advance\labelwidth-\labelsep}
%% <\input{size1\@ptsize.clo}>

\setlength\lineskip{1\p@}
\setlength\normallineskip{1\p@}
\renewcommand\baselinestretch{}
%\setlength\parskip{0\p@ \@plus \p@}
\parskip\z@
\@lowpenalty   51
\@medpenalty  151
\@highpenalty 301

\setcounter{topnumber}{5}% 2
\setcounter{bottomnumber}{4}% 1
\setcounter{totalnumber}{9}% 3
\setcounter{dbltopnumber}{5}% 2
\renewcommand{\topfraction}{.95}% .7
\renewcommand{\bottomfraction}{.95}% .3
\renewcommand{\textfraction}{.05}% .2
\renewcommand{\floatpagefraction}{.05}% .5
\renewcommand{\dbltopfraction}{.95}% .7
\renewcommand{\dblfloatpagefraction}{.05}% .5

\if@Proof
 \def\@Rtop{\rlap{\smash{\rule[-\headsep]{0.05mm}{10mm}%
  \rule[-\headsep]{10mm}{0.05mm}}}}
 \def\@Ltop{\llap{\smash{\rule[-\headsep]{10mm}{0.05mm}%
  \rule[-\headsep]{0.05mm}{10mm}}}}
 \def\@Rbot{\rlap{\smash{\raisebox{1\footskip}
  {\rule[-10mm]{0.05mm}{10mm}\rule{10mm}{0.05mm}}}}}
 \def\@Lbot{\llap{\smash{\raisebox{1\footskip}
  {\rule{10mm}{0.05mm}\rule[-10mm]{0.05mm}{10mm}}}}}
\else
 \let\@Rtop\relax\let\@Ltop\relax\let\@Rbot\relax\let\@Lbot\relax
\fi

\def\Year#1{%
 \def\@tempa{#1}%
 \ifx\@tempa\empty
  \gdef\@Year{201x}%
 \else
  \edef\@tempb{\zap@space#1 \@empty}%
  \afterassignment\remove@to@nnil
  \count@ 0\@tempb\relax\@nnil
  \ifnum\count@=\z@
   \xdef\@Year{201x}%
  \else
   \xdef\@Year{\@tempb}%
  \fi
 \fi
}
\def\@Year{201x}

\def\Vol#1{% Vol.43 = Year 2010
 \def\@tempa{#1}%
 \ifx\@tempa\empty
  \gdef\@Vol{xx}%
  %\gdef\@Year{201x}%
 \else
  \edef\@tempb{\zap@space#1 \@empty}%
  \afterassignment\remove@to@nnil
  \count@ 0\@tempb\relax\@nnil
  \ifnum\count@=\z@
   \gdef\@Vol{xx}%
  \else
   %\@tempcnta=#1\relax
   %\advance \@tempcnta 1967\relax
   %\xdef\@Year{\the\@tempcnta}%
   \gdef\@Vol{\zap@space#1 \@empty}%
  \fi
 \fi
}
\def\@Vol{xx}%

\def\No#1{%
 \def\@tempa{#1}%
 \ifx\@tempa\empty
  \gdef\@No{x}%
 \else
  \edef\@tempb{\zap@space#1 \@empty}%
  \afterassignment\remove@to@nnil
  \count@ 0\@tempb\relax\@nnil
  \ifnum\count@=\z@
   \gdef\@No{x}%
  \else
   \gdef\@No{\zap@space#1 \@empty}%
  \fi
 \fi
}
\def\@No{x}%

\def\nombre@font{\normalfont\fontsize{9.5}{\z@}\selectfont\sffamily\bfseries}
\def\oddfoot@font{\normalfont\small\bfseries}
\def\evenfoot@font{\normalfont\fontsize{9.5}{\z@}\selectfont\sffamily\bfseries}
\def\fphead@font{\normalfont\footnotesize}

\def\jcej@journal{Journal of Chemical Engineering of Japan}
\def\jcej@copyright{Copyright\ \copyright\ \@Year\ 
 The Society of Chemical Engineers, Japan}

\def\ps@jcej{%
 \def\@oddhead{\@Ltop\hfil\@Rtop}%
 \let\@evenhead\@oddhead
 \def\@oddfoot{\@Lbot
  \@tempcnta\z@
  \@ifundefined{r@jcej@firstpage}{}%
   {\expandafter\@tempcnta\pageref{jcej@firstpage}%
    \advance \@tempcnta \@ne}%
   \ifnum\c@page=\@tempcnta
    \hfil
   \else
    {\oddfoot@font VOL.\,\@Vol\ \ NO.\,\@No\ \ \@Year}\hfil
  \fi
  {\nombre@font\thepage}\@Rbot}%
 \def\@evenfoot{\@Lbot
  {\nombre@font\thepage}\hfil
  {\evenfoot@font \expandafter\uppercase\expandafter{\jcej@journal}}%
  \@Rbot}%
 \let\@mkboth\markboth
 %
}

\def\head@underline{\smash{\hbox to \z@{\hbox to \textwidth{%
  \leaders\hrule \@height -1.45mm \@depth 1.55mm\hfil}\hss}}}
\def\foot@overline{\smash{\hbox to \z@{\hbox to \textwidth{%
  \leaders\hrule \@height 4.3mm \@depth -4.2mm\hfil}\hss}}}

\def\ps@FPjcej{%
 \def\@oddhead{\@Ltop\head@underline
  {\fphead@font \jcej@journal, 
   Vol.\,\@Vol, No.\,\@No, pp.\,\thepage--\pageref{jcej@lastpage}, \@Year}\hfil
  {\nombre@font\itshape \jcej@type}\@Rtop}%
 \let\@evenhead\@oddhead
 \def\@oddfoot{\@Lbot\foot@overline
  {\fphead@font \jcej@copyright}\hfil
  {\nombre@font\thepage}\@Rbot}%
 \def\@evenfoot{\@Lbot\foot@overline
  {\nombre@font\thepage}\hfil
  {\fphead@font \jcej@copyright}\@Rbot}%
 \let\@mkboth\markboth
 %
}

\def\title@font{\sffamily\bfseries\fontsize{17}{18}\selectfont}% 16
\def\authorname@font{\normalfont\normalsize}
\def\affiliate@font{\normalfont\footnotesize\itshape}

\def\title#1{\gdef\@title{#1}}
\def\@title{}

%% <author>
\newtoks\@authorlist
\newcount\@authorcnt
\newcount\@alcnt
\newcount\chk@alcnt
\newcount\p@alcnt
\newcount\chk@p@alcnt
\newcount\total@nr

\def\authorlist#1{%
 \@authorlist={#1}\the\@authorlist
}

\def\authorentry#1#2{\@ifnextchar[% ]
 {\jcej@aeP{#1}{#2}}{\jcej@ae{#1}{#2}}}

\def\chk@spaceofauthor{%
 \setbox\@tempboxa\hbox{{\spaceskip=100mm \the\@temptokena}}%
 \ifdim \wd\@tempboxa < 100mm
  \jcej@warning{a space should be added to the name "\the\@temptokena"}%
  \def\tmp@name##1\@nil{##1}%
 \else
  \def\tmp@name##1 ##2\@nil{##1 \protect\scshape{##2}}%
 \fi
}

\def\jcej@ae#1#2{%
 \def\tmp@an{#1}%
 \ifx\tmp@an\empty
 \else
  \@tempcnta\z@
  \advance \@authorcnt \@ne
  %% author's label
  \get@al{#2}%
  %% author's name
  \@temptokena{#1}%
  \chk@spaceofauthor
  \protected@edef\fmt@authorname{%
    \expandafter\tmp@name\the\@temptokena\@nil}%
  \expandafter\protected@xdef\csname @Eauthorname\number\@authorcnt\endcsname{%
   \fmt@authorname\unskip\kern\z@\protect\save@affi{\plural@affi}}%
  \global\total@nr\@authorcnt
  \def\plural@affi{}%
 \fi
}
\def\save@affi#1{#1}

\def\jcej@aeP#1#2[#3]{%
 \def\tmp@an{#1}%
 \ifx\tmp@an\empty
 \else
  \@tempcnta\z@
  \advance \@authorcnt \@ne
  %% author's label
  \get@al{#2}%
  %% author's label (present address)
  \@ifundefined{p@al@#3}{\global\advance \p@alcnt \@ne
   \expandafter\xdef\csname p@al@#3\endcsname{\the\p@alcnt}% 
  }{}%
  %% author's name
  \@temptokena{#1}%
  \chk@spaceofauthor
  \protected@edef\fmt@authorname{%
    \expandafter\tmp@name\the\@temptokena\@nil}%
  \expandafter\protected@xdef\csname @Eauthorname\number\@authorcnt\endcsname{%
   \fmt@authorname\unskip\kern\z@\protect\save@affi{\plural@affi}\kern0pt
   $^{\jcej@fnsymbol{\the\p@alcnt}}$%
  }%
  \global\total@nr\@authorcnt
  \def\plural@affi{}%
 \fi
}

\def\get@al#1{%
 \def\al@none{none}\def\@tempaffi{#1}%
 \ifx\al@none\@tempaffi\else
  \@for\get@label:=#1\do{%
   \@ifundefined{chk@\get@label}{\global\advance \chk@alcnt \@ne
    \expandafter\gdef\csname chk@\get@label\endcsname{}%
   }{}%
   \expandafter\def\expandafter\save@al\expandafter{%
    \csname al@\get@label\endcsname}%
   \advance \@tempcnta \@ne
   \protected@xdef\plural@affi{\plural@affi
    \ifnum\@tempcnta=\@ne
     $^{\noexpand\protect\save@al}$%
    \else
     $^{,\noexpand\protect\save@al}$%
    \fi
   }%
  }%
 \fi
}
\def\plural@affi{}

\def\affiliate[#1]#2{%
 \advance \@alcnt \@ne
 \expandafter\xdef\csname al@#1\endcsname{\the\@alcnt}% 
 \protected@xdef\@affiliate{%
  \@affiliate\par
  \@hangfrom{$^{\the\@alcnt}$}\ignorespaces #2}%
}
\def\@affiliate{}

\long\def\paffiliate[#1]#2{%
 \advance \chk@p@alcnt \@ne
 \@ifundefined{p@al@#1}%
  {\expandafter\def\csname p@al@#1\endcsname{1}%
   \jcej@warning{check the "#1" label, it does not correspond to
     ^^J\@spaces label in \string\authorentry\space command}%
  }{}%
 \protected@xdef\p@affiliate{%
  \p@affiliate
  \protect\footnotetext[\csname p@al@#1\endcsname]{#2}}%
}
\def\p@affiliate{}

\newif\if@jcej@linebreak \@jcej@linebreakfalse
\def\breakauthorline#1{%
 \global\@jcej@linebreaktrue
 \@for\@breakauthor:=#1\do{%
  \expandafter\gdef\csname @breakauthorline\@breakauthor\endcsname{\\}%
 }%
  \@authorcnt=\z@
  \loop\ifnum\@authorcnt<\total@nr
   \advance \@authorcnt \@ne
    \@ifundefined{@breakauthorline\number\@authorcnt}%
     {\expandafter\gdef\csname @breakauthorline\number\@authorcnt\endcsname{%
      \relax}}
     {\relax}%
  \repeat
}

\def\output@Eauthorlist{%
 \@authorcnt\z@
 \@tempcnta\total@nr \advance \@tempcnta -\@ne
  \loop
   \ifnum \@authorcnt < \total@nr
    \advance \@authorcnt \@ne 
    \ifnum \@authorcnt < \@tempcnta
     \ignorespaces
     \mbox{\ignorespaces
      \csname @Eauthorname\number\@authorcnt\endcsname\unskip}, 
     \csname @breakauthorline\number\@authorcnt\endcsname
    \else
     \ifnum \@authorcnt=\total@nr
      \ignorespaces
      \mbox{\ignorespaces
       \csname @Eauthorname\number\@authorcnt\endcsname\unskip}%
      \csname @breakauthorline\number\@authorcnt\endcsname
      \ignorespaces
     \else
      \ignorespaces
      \mbox{\ignorespaces
       \csname @Eauthorname\number\@authorcnt\endcsname\unskip}\ 
      \csname @breakauthorline\number\@authorcnt\endcsname
      %% \ifnum \total@nr=\tw@\ \else , \fi
      and\ \ignorespaces 
     \fi
    \fi
  \repeat
}
%% </author>

\newbox\@keywordbox
\def\keywords{%
 \global\setbox\@keywordbox\hbox\bgroup
  \footnotesize\baselineskip12pt
  \ignorespaces
}
\def\endkeywords{%
 \egroup
}

\newbox\@abstractbox
\def\abstract{%
 \global\setbox\@abstractbox\hbox\bgroup
  \footnotesize\baselineskip12pt
  \bfseries
  \ignorespaces
}
\def\endabstract{%
 \egroup
}

\def\received#1#2#3{%
 \def\tmp@m{#2}%
 \ifx\tmp@m\empty\def\tmp@m{0}\fi
 \protected@edef\rec@month{%
  \ifcase\tmp@m xxx\or January\or February\or March\or April\or
    May\or June\or July\or August\or September\or October\or
    November\or December\else
     #2%
     \typeout{Class jcej Warning: 
      check "#2" of \string\received\space command!}%
    \fi}%
 \gdef\@received{Received on \rec@month\ \ignorespaces #3\unskip, 
  \ignorespaces #1}%
}
\def\@received{}

\def\accepted#1#2#3{%
 \def\tmp@m{#2}%
 \ifx\tmp@m\empty\def\tmp@m{0}\fi
 \protected@edef\acp@month{%
  \ifcase\tmp@m xxx\or January\or February\or March\or April\or
    May\or June\or July\or August\or September\or October\or
    November\or December\else
     #2%
     \typeout{Class jcej Warning: 
      check "#2" of \string\accepted\space command!}%
    \fi}%
 \gdef\@accepted{accepted on \acp@month\ \ignorespaces #3\unskip, 
  \ignorespaces #1}%
}
\def\@accepted{}

\def\@acceptance{\par
 \ifx \@received\empty\else
  \ifx\@accepted\empty
   \footnotetext[0]{\@received.}%
  \else
   \footnotetext[0]{\@received; \@accepted}%
  \fi
 \fi
}

\long\def\correspondence#1{%
 \gdef\@correspondence{%
  \footnotetext[0]{%
   Correspondence concerning this article should be addressed to\linebreak
   \ignorespaces #1}%
 }%
}
\def\@correspondence{}

\long\def\presented#1{%
 \gdef\@presented{%
  \footnotetext[0]{\ignorespaces #1}%
 }%
}
\def\@presented{}

\def\jcej@fnsymbol#1{%
 \ifcase#1 \or {*}\or {*}{*}\or {*}{*}{*}\or {*}{*}{*}{*}\or 
  {*}{*}{*}{*}{*}\or {*}{*}{*}{*}{*}{*}\or
  \else\@ctrerr\fi}

\newcommand\maketitle{\par
 \begingroup
  \let\@fnsymbol\jcej@fnsymbol
  \def\thefootnote{\fnsymbol{footnote}}%
  \long\def\@makefntext##1{\leftskip16pt\parindent\z@
   \leavevmode
   \hbox to \z@{\hss\hbox to 16pt{$^{\@thefnmark}$\hss}}%
   ##1}%
  %%
  \twocolumn[\@maketitle]%
  \thispagestyle{FPjcej}%
  \@acceptance
  \@correspondence
  \p@affiliate
  \@presented
 \endgroup
 \setcounter{footnote}{0}%
 \global\let\maketitle\relax
 \global\let\@maketitle\relax
 \global\let\@received\@empty
 \global\let\@accepted\@empty
 \global\let\@correspondence\@empty
 \global\let\@presented\@empty
 \global\let\received\relax
 \global\let\accepted\relax
 \global\let\@acceptance\relax
 \global\let\correspondence\relax
 \global\let\presented\relax
 %%
 \ifnum \@alcnt=\chk@alcnt\else
  \jcej@warning{label of \string\affiliate\space is not specified}%
 \fi
 \ifnum \chk@p@alcnt=\p@alcnt\else
  \jcej@warning{information of \string\paffiliate\space is not specified}%
 \fi
}

\def\@maketitle{%
 \setbox\@tempboxa\vbox{\hsize\textwidth
  \parindent\z@
  \baselineskip12pt
  \bgroup
   \vskip2.775\baselineskip
   {\title@font \@title\par}%
  \egroup
  \vskip14pt
  \bgroup
   \leftskip144pt
   \ifnum\@alcnt=\@ne
    \let\save@affi\@gobble
    \let\@hangfrom\@gobble
   \fi
   \if@jcej@linebreak
    {\authorname@font \output@Eauthorlist\par}%
    \rightskip90pt \@plus 1fil % 480-384=96
    {\affiliate@font \@affiliate\par}%
   \else
    \rightskip90pt \@plus 1fil % 480-384=96
    {\authorname@font \output@Eauthorlist\par}%
    \unskip
    {\affiliate@font \@affiliate\par}%
   \fi
  \egroup
  \vskip2\baselineskip
  \vskip4pt
  \begin{minipage}{384pt}
   \footnotesize\baselineskip12pt
   \@hangfrom{{\bfseries\itshape Keywords}:\hskip8pt}%
   \unhbox\@keywordbox\par
   \vskip1\baselineskip
   \parindent8pt
   \leavevmode
   \unhbox\@abstractbox\par
  \end{minipage}%
 }%
 %%
 \@tempdima \ht\@tempboxa
 \advance \@tempdima \dp\@tempboxa
 \@tempdimb \@tempdima
 \@tempdimc \@tempdima
 \divide \@tempdimc \baselineskip
 \@tempcnta=\@tempdimc
 \advance \@tempcnta \@ne
 \@tempdimc \@tempcnta\baselineskip
 \advance \@tempdimb -\@tempdimc
 \ifdim \@tempdimb > .5\baselineskip
  \advance \@tempcnta \thr@@
 \else
  \advance \@tempcnta \tw@
 \fi
 %%
 \newpage\null
 \bgroup
  \parindent\z@
  \boxmaxdepth\z@
  \lineskiplimit\z@
  \lineskip\z@
  \vbox to \@tempcnta\baselineskip{%
   \box\@tempboxa
  \vss}%
 \egroup
}

\setcounter{secnumdepth}{3}
\newcounter {section}
\newcounter {subsection}[section]
\newcounter {subsubsection}[subsection]
\newcounter {paragraph}[subsubsection]
\newcounter {subparagraph}[paragraph]
\renewcommand\thesection{\@arabic\c@section}
\renewcommand\thesubsection{\thesection.\@arabic\c@subsection}
\renewcommand\thesubsubsection{\thesubsection .\@arabic\c@subsubsection}
\renewcommand\theparagraph{\thesubsubsection.\@arabic\c@paragraph}
\renewcommand\thesubparagraph{\theparagraph.\@arabic\c@subparagraph}

\def\@afterheading{%
 \global\@nobreaktrue
 \everypar{%
  \if@nobreak
   \global\@nobreakfalse
   \clubpenalty \z@
    \if@afterindent
    \else
     {\setbox\z@=\lastbox}%
    \fi
  \else
   \clubpenalty\@clubpenalty
   \everypar{}%
  \fi}%
}

%% \@startsection{NAME}{LEVEL}{INDENT}{BEFORESKIP}{AFTERSKIP}{STYLE}
\def\@startsection#1#2#3#4#5#6{\if@noskipsec \leavevmode \fi
  \par \@tempskipa #4\relax
  \@afterindenttrue
  \ifdim \@tempskipa <\z@ \@tempskipa -\@tempskipa \@afterindentfalse\fi
  \if@nobreak
   \everypar{}%
  \else
   \ifnum#2=\@ne
    \vskip-\prevdepth \prevdepth\z@ \vskip\baselineskip
    \advance\@tempskipa-\baselineskip
    \advance\@tempskipa-\baselineskip
    \vspace{\baselineskip}
    \vspace*{\@tempskipa}
   \else
    \addvspace\@tempskipa
   \fi
  \fi
 \@ifstar{\@ssect{#3}{#4}{#5}{#6}}{\@dblarg{\@sect{#1}{#2}{#3}{#4}{#5}{#6}}}}

%% \@sect{NAME}{LEVEL}{INDENT}{BEFORESKIP}{AFTERSKIP}{STYLE}[ARG1]{ARG2}
%% \ifdim \@tempskipa>\z@ --> \ifdim \@tempskipa<\z@
\def\@sect#1#2#3#4#5#6[#7]#8{%
 \ifnum #2>\c@secnumdepth
  \let\@svsec\@empty
 \else
  \refstepcounter{#1}%
  \protected@edef\@svsec{\@seccntformat{#1}\relax}%
 \fi
  \@tempskipa #5\relax
  \ifdim \@tempskipa<\z@
   \ifnum#2=\thr@@
    \def\@svsechd{%
     #6{\ul{\thesubsubsection{\kern1em}#8}}%
    }%
   \else
    %\def\@svsechd{%
    % #6{\hskip #3\relax
    %  \@svsec\hskip1em #8}}%
    \def\@svsechd{%
     #6{#8}}%
   \fi
  \else
   \begingroup
    #6{%
       \@hangfrom{\hbox to \save@parindent{\@svsec\hss}}%
        \interlinepenalty\@M #8\@@par
      }%
   \endgroup
  \fi
  \@xsect{#5}%
}

%% \@ssect{INDENT}{BEFORESKIP}{AFTERSKIP}{STYLE}{ARG} ==
%% \ifdim \@tempskipa>\z@ --> \ifdim \@tempskipa<\z@
\def\@ssect#1#2#3#4#5{%
  \@tempskipa #3\relax
  \ifdim \@tempskipa<\z@
   \def\@svsechd{#4{\hskip #1\relax #5}}%
  \else
    \begingroup
     #4{%
        \@hangfrom{\hskip #1}\interlinepenalty\@M
       #5\@@par
       }%
    \endgroup
  \fi
  \@xsect{#3}%
}

%% \ifdim \@tempskipa>\z@ --> \ifdim \@tempskipa<\z@
\def\@xsect#1{%
  \@tempskipa #1\relax
  \ifdim \@tempskipa<\z@
    \@nobreakfalse
    \global\@noskipsectrue
    \everypar{%
      \if@noskipsec
        \global\@noskipsecfalse
       {\setbox\z@\lastbox}%
        \clubpenalty\@M
        \begingroup \@svsechd \endgroup
        \unskip
        \@tempskipa #1\relax
        \hskip -\@tempskipa
        \pagebreak[2]%
      \else
        \clubpenalty \@clubpenalty
        \everypar{}%
      \fi}%
  \else
    \par \nobreak
    \vskip \@tempskipa
    \@afterheading
  \fi
  \ignorespaces}

\def\@seccntformat#1{\csname the#1\endcsname
 \csname dotafter@#1\endcsname}
\def\dotafter@section{.}

\def\section{\@startsection{section}{1}{\z@}% }{
   {1.5\baselineskip \@plus.5ex \@minus.2ex}%
   {.5\baselineskip \@plus.3ex \@minus.2ex}%
   {\normalsize\bfseries}}
\def\subsection{\@startsection{subsection}{2}{\z@}% }{
   {\z@ \@plus.3ex}%
   {\z@ \@plus.3ex}%
   {\normalsize\bfseries}}
\def\subsubsection{\@startsection{subsubsection}{3}{\z@}% }{
   {\z@ \@plus.3ex}%
   {-20pt}%
   {\normalsize}}
\def\paragraph{\@startsection{paragraph}{4}{\z@}% }{
   {\z@ \@plus.3ex}%
   {-20pt}%
   {\normalsize}}
\def\subparagraph{\@startsection{subparagraph}{5}{\z@}% }{
   {\z@ \@plus.3ex}%
   {-20pt}%
   {\normalsize}}

\newcommand\appendix{%
 \setcounter{section}{0}%
 \setcounter{subsection}{0}%
 \setcounter{figure}{0}%
 \setcounter{table}{0}%
 \renewcommand\thefigure{A\@arabic\c@figure}%
 \renewcommand\thetable{A\@arabic\c@table}%
 \setcounter{equation}{0}%
 \renewcommand\theequation{A\@arabic\c@equation}%
 \def\section{\@startsection{section}{1}{\z@}% }{
    {\z@ \@plus.3ex}%
    {\z@ \@plus.3ex}%
    {\footnotesize}}%
 \def\subsection{\@startsection{subsection}{2}{\z@}% }{
    {\z@ \@plus.3ex}%
    {\z@ \@plus.3ex}%
    {\footnotesize}}%
 \footnotesize
 \vskip\baselineskip
 \noindent
 {\bfseries \appendixname}\par
 \nopagebreak
}

\if@twocolumn
  \setlength\leftmargini  {2em}
\else
  \setlength\leftmargini  {2.5em}
\fi
\leftmargin  \leftmargini
\setlength\leftmarginii  {2.2em}
\setlength\leftmarginiii {1.87em}
\setlength\leftmarginiv  {1.7em}
\if@twocolumn
  \setlength\leftmarginv  {.5em}
  \setlength\leftmarginvi {.5em}
\else
  \setlength\leftmarginv  {1em}
  \setlength\leftmarginvi {1em}
\fi
\setlength  \labelsep  {.5em}
\setlength  \labelwidth{\leftmargini}
\addtolength\labelwidth{-\labelsep}
\@beginparpenalty\z@ % -\@lowpenalty
\@endparpenalty\z@ %   -\@lowpenalty
\@itempenalty\z@ %     -\@lowpenalty

\renewcommand\theenumi{\@arabic\c@enumi}
\renewcommand\theenumii{\@alph\c@enumii}
\renewcommand\theenumiii{\@roman\c@enumiii}
\renewcommand\theenumiv{\@Alph\c@enumiv}
\newcommand\labelenumi{\hbox to \save@parindent{\theenumi.\hss}}
\newcommand\labelenumii{\hbox to \save@parindent{(\theenumii)\hss}}
\newcommand\labelenumiii{\hbox to \save@parindent{\theenumiii.\hss}}
\newcommand\labelenumiv{\hbox to \save@parindent{\theenumiv.\hss}}
\renewcommand\p@enumii{\theenumi}
\renewcommand\p@enumiii{\theenumi(\theenumii)}
\renewcommand\p@enumiv{\p@enumiii\theenumiii}

\renewenvironment{enumerate}
  {\ifnum \@enumdepth >3\relax\@toodeep\else
   \advance\@enumdepth\@ne
   \edef\@enumctr{enum\romannumeral\the\@enumdepth}%
   \list{\csname label\@enumctr\endcsname}{%
         \topsep\z@\parsep\z@\partopsep\z@\itemsep\z@
         \labelwidth\save@parindent
         \labelsep\z@
         \leftmargin\labelwidth
         %\advance\leftmargin \labelsep
         \listparindent\z@
         \clubpenalty\z@
         \widowpenalty\z@
         \@itempenalty\z@
         \usecounter{\@enumctr}%
         \def\makelabel##1{{##1}\hss}}%
   \fi}{\endlist}

\newcommand\labelitemi{\hbox to \save@parindent{\textbullet\hss}}
\newcommand\labelitemii{\hbox to \save@parindent{%
 \normalfont\bfseries \textendash\hss}}
\newcommand\labelitemiii{\hbox to \save@parindent{\textasteriskcentered\hss}}
\newcommand\labelitemiv{\hbox to \save@parindent{\textperiodcentered\hss}}

\renewenvironment{itemize}
  {\ifnum \@itemdepth >3\relax\@toodeep\else
   \advance\@itemdepth\@ne
   \edef\@itemitem{labelitem\romannumeral\the\@itemdepth}%
   \expandafter
   \list{\csname \@itemitem\endcsname}{%
         \topsep\z@\parsep\z@\partopsep\z@\itemsep\z@
         \labelwidth\save@parindent
         \labelsep\z@
         \leftmargin\labelwidth
         %\advance\leftmargin \labelsep
         \listparindent\z@
         \clubpenalty\z@
         \widowpenalty\z@
         \@itempenalty\z@
         \def\makelabel##1{{##1}\hss}}%
   \fi}{\endlist}

\newenvironment{description}
               {\list{}{%
                  \topsep\z@\parsep\z@\partopsep\z@\itemsep\z@
                  \labelwidth\z@ \itemindent-\leftmargin
                  \let\makelabel\descriptionlabel}}
               {\endlist}
\newcommand*\descriptionlabel[1]{\hspace\labelsep
                                \normalfont\bfseries #1}

\newenvironment{verse}
               {\let\\\@centercr
                \list{}{%
                        \topsep\z@\parsep\z@\partopsep\z@\itemsep\z@
                        \itemsep      \z@
                        \itemindent   -1.5em%
                        \listparindent\itemindent
                        \rightmargin  \leftmargin
                        \advance\leftmargin 1.5em}%
                \item\relax}
               {\endlist}

\newenvironment{quotation}
               {\list{}{%
                        \topsep\z@\parsep\z@\partopsep\z@\itemsep\z@
                        \listparindent\parindent % 1.5em%
                        \itemindent\parindent %\listparindent
                        \rightmargin\leftmargin
                       }%
                \item\relax}
               {\endlist}

\newenvironment{quote}
               {\list{}{%
                        \topsep\z@\parsep\z@\partopsep\z@\itemsep\z@
                        \rightmargin\leftmargin}%
                \item\relax}
               {\endlist}

\gdef\tabbing{\lineskip \z@skip\let\>\@rtab\let\<\@ltab\let\=\@settab
     \let\+\@tabplus\let\-\@tabminus\let\`\@tabrj\let\'\@tablab
     \let\\=\@tabcr
     \@hightab\@firsttab
     \global\@nxttabmar\@firsttab
     \dimen\@firsttab\@totalleftmargin
     \global\@tabpush\z@ \global\@rjfieldfalse
     \topsep\z@ \parsep\z@\partopsep\z@
     \trivlist \item\relax
     \if@minipage\else\vskip\parskip\fi
     \setbox\@tabfbox\hbox{%
       \rlap{\hskip\@totalleftmargin\indent\the\everypar}}%
     \def\@itemfudge{\box\@tabfbox}%
     \@startline\ignorespaces}

\newdimen\verbatimleftmargin
  \verbatimleftmargin\z@
\newdimen\verbatimbaselineskip
  \verbatimbaselineskip\baselineskip
\def\verbatimsize{\normalsize}
%\def\verbatim@font{\normalfont\ttfamily}

\def\@verbatim{%
 \interlinepenalty\z@
 \topsep\z@
 \partopsep\z@\parsep\z@\itemsep\z@
 \trivlist \item\relax
  \if@minipage\else
   \vskip\baselineskip
   \vskip-\verbatimbaselineskip
   %\vskip\parskip
  \fi
  \leftskip\@totalleftmargin
  \if@minipage\else
   \advance \leftskip by \verbatimleftmargin
  \fi
  \rightskip\z@skip
  \parindent\z@\parfillskip\@flushglue\parskip\z@skip
  \@@par
  \@tempswafalse
  \def\par{%
    \if@tempswa
      \leavevmode \null \@@par\penalty\interlinepenalty
    \else
      \@tempswatrue
      \ifhmode\@@par\penalty\interlinepenalty\fi
    \fi}%
  \let\do\@makeother \dospecials
  \obeylines 
   \verbatimsize \baselineskip\verbatimbaselineskip
   \verbatim@font \@noligs
  \everypar \expandafter{\the\everypar \unpenalty}%
}

%% from latex.ltx
\def\@item[#1]{%
  \if@noparitem
    \@donoparitem
  \else
    \if@inlabel
      \indent \par
    \fi
    \ifhmode
      \unskip\unskip \par
    \fi
    \if@newlist
      \if@nobreak
        \@nbitem
      \else
        \addpenalty\@beginparpenalty
        \addvspace\@topsep
        \addvspace{-\parskip}%
      \fi
    \else
      \addpenalty\@itempenalty
      \addvspace\itemsep
    \fi
    \global\@inlabeltrue
  \fi
  \everypar{%
    \@minipagefalse
    \global\@newlistfalse
    \if@inlabel
      \global\@inlabelfalse
      {\setbox\z@\lastbox
       \ifvoid\z@
         \kern-\itemindent
       \fi}%
      \box\@labels
      \penalty\z@
    \fi
    \if@nobreak
      \@nobreakfalse
      \clubpenalty\z@ % \@M --> \z@ 
    \else
      \clubpenalty \@clubpenalty
      \everypar{}%
    \fi}%
  \if@noitemarg
    \@noitemargfalse
    \if@nmbrlist
      \refstepcounter\@listctr
    \fi
  \fi
  \sbox\@tempboxa{\makelabel{#1}}%
  \global\setbox\@labels\hbox{%
    \unhbox\@labels
    \hskip \itemindent
    \hskip -\labelwidth
    \hskip -\labelsep
    \ifdim \wd\@tempboxa >\labelwidth
      \box\@tempboxa
    \else
      \hbox to\labelwidth {\unhbox\@tempboxa}%
    \fi
    \hskip \labelsep}%
  \ignorespaces
}

\setlength\arraycolsep{5\p@}
\setlength\tabcolsep{6\p@}
\setlength\arrayrulewidth{.3\p@}% .4\p@
\setlength\doublerulesep{\z@}% 2\p@
\setlength\tabbingsep{\labelsep}
\skip\@mpfootins = \skip\footins
\setlength\fboxsep{3\p@}
\setlength\fboxrule{.4\p@}

\renewcommand \theequation {\@arabic\c@equation}

\newcounter{figure}
\renewcommand\thefigure{\@arabic\c@figure}
\def\fps@figure{tb}
\def\ftype@figure{1}
%\def\ext@figure{lof}
\def\fnum@figure{\figurename\nobreakspace\thefigure}
\newenvironment{figure}
               {\floatenv
                \abovecaptionskip3pt\belowcaptionskip\z@\@float{figure}}
               {\end@float}
\newenvironment{figure*}
               {\floatenv
                \abovecaptionskip3pt\belowcaptionskip\z@\@dblfloat{figure}}
               {\end@dblfloat}

\newcounter{table}
\renewcommand\thetable{\@arabic\c@table}
\def\fps@table{tb}
\def\ftype@table{2}
%\def\ext@table{lot}
\def\fnum@table{\tablename\nobreakspace\thetable}
\newenvironment{table}
               {\floatenv
                \abovecaptionskip\z@\belowcaptionskip4pt\@float{table}}
               {\end@float}
\newenvironment{table*}
               {\floatenv
                \abovecaptionskip\z@\belowcaptionskip4pt\@dblfloat{table}}
               {\end@dblfloat}

\def\@floatboxreset {%
 \reset@font
 \small\tabcolsep.5em
 \@setminipage
}

\newlength\abovecaptionskip
\newlength\belowcaptionskip

\def\Center{\topsep\z@\parsep\z@\partopsep\z@\itemsep\z@
 \trivlist \centering\item\relax}
\def\endCenter{\unskip\endtrivlist}
\def\floatenv{\let\center\Center}

\long\def\@caption#1[#2]#3{\par
 %\addcontentsline{\csname ext@#1\endcsname}{#1}%
 % {\protect\numberline{\csname the#1\endcsname}{\ignorespaces #2}}%
 \begingroup
  \@parboxrestore
  \if@minipage
   \@setminipage
  \fi
  \small
  \@makecaption{\csname fnum@#1\endcsname}{\ignorespaces #3}\par
 \endgroup
}

\let\capnum@font\bfseries

\long\def\@makecaption#1#2{%
 \vskip\abovecaptionskip
 \setbox\@tempboxa\hbox{{\capnum@font #1}\hskip1em #2}%
 \ifdim\wd\@tempboxa>\hsize
  \@hangfrom{{\capnum@font #1}\hskip1em}#2\par
 \else
  \global \@minipagefalse
  \hb@xt@\hsize{\hss\box\@tempboxa\hss}%
 \fi
 \vspace{\belowcaptionskip}%
}

\@ifundefined{@needsPformat}{}{% for japanese pLaTeX
 \if@enablejfam
  \if@compatibility\else
    \DeclareSymbolFont{mincho}{JY1}{mc}{m}{n}
    \DeclareSymbolFontAlphabet{\mathmc}{mincho}
    \SetSymbolFont{mincho}{bold}{JY1}{gt}{m}{n}
    \jfam\symmincho
    \DeclareMathAlphabet{\mathgt}{JY1}{gt}{m}{n}
  \fi
  \if@mathrmmc
    \AtBeginDocument{%
    \reDeclareMathAlphabet{\mathrm}{\mathrm}{\mathmc}
    \reDeclareMathAlphabet{\mathbf}{\mathbf}{\mathgt}
  }%
  \fi
 \else
  \DeclareRobustCommand{\mathmc}{%
    \@latex@error{Command \noexpand\mathmc invalid with\space
       `disablejfam' class option.}\@eha
  }
  \DeclareRobustCommand{\mathgt}{%
    \@latex@error{Command \noexpand\mathgt invalid with\space
       `disablejfam' class option.}\@eha
  }
 \fi
}

\@ifundefined{@needsPformat}{}{% for japanese pLaTeX
 \DeclareOldFontCommand{\mc}{\normalfont\mcfamily}{\mathmc}%
 \DeclareOldFontCommand{\gt}{\normalfont\gtfamily}{\mathgt}%
}
\DeclareOldFontCommand{\rm}{\normalfont\rmfamily}{\mathrm}
\DeclareOldFontCommand{\sf}{\normalfont\sffamily}{\mathsf}
\DeclareOldFontCommand{\tt}{\normalfont\ttfamily}{\mathtt}
\DeclareOldFontCommand{\bf}{\normalfont\bfseries}{\mathbf}
\DeclareOldFontCommand{\it}{\normalfont\itshape}{\mathit}
\DeclareOldFontCommand{\sl}{\normalfont\slshape}{\@nomath\sl}
\DeclareOldFontCommand{\sc}{\normalfont\scshape}{\@nomath\sc}
\DeclareRobustCommand*\cal{\@fontswitch\relax\mathcal}
\DeclareRobustCommand*\mit{\@fontswitch\relax\mathnormal}

\def\Acknowledgments{%
 \onelineskip
 \footnotesize
 \noindent
 {\bfseries Acknowledgments}\par
 \nopagebreak
}
\def\endAcknowledgments{\par}

\def\Nomenclature{%
 \onelineskip
 \footnotesize
 \parindent\z@
 \noindent
 {\bfseries Nomenclature}\par
 \nopagebreak
}
\def\endNomenclature{\par}

\newdimen\bibindent
\setlength\bibindent{1.5em}
\newenvironment{thebibliography}[1]
     {\footnotesize
      \vskip\baselineskip
      \subsection*{\footnotesize\refname}%
      \list{\@biblabel{\@arabic\c@enumiv}}% 
           {\topsep\z@\parsep\z@\partopsep\z@\itemsep\z@
            %\settowidth\labelwidth{\@biblabel{#1}}%
            \leftmargin15pt
            \@openbib@code
            \itemindent-15pt
            \usecounter{enumiv}%
            \let\p@enumiv\@empty
            \renewcommand\theenumiv{\@arabic\c@enumiv}
            }%
      \sloppy
      \clubpenalty\z@ %4000
      \@clubpenalty \clubpenalty
      \widowpenalty\z@ %4000%
      \sfcode`\.\@m}
     {\def\@noitemerr
       {\@latex@warning{Empty `thebibliography' environment}}%
      \endlist}

%\def\@biblabel#1{[#1]}
\def\@biblabel#1{}% #1

\newcommand\newblock{\hskip .11em\@plus.33em\@minus.07em}
\let\@openbib@code\@empty

\def\bibauthoryear#1#2{#1 (#2)}
\def\citeauthoryear{\def\bibauthoryear##1##2{##1 (##2)}\cite}
\def\citeauthor{\def\bibauthoryear##1##2{##1}\cite}
\def\citeyear{\def\bibauthoryear##1##2{##2}\cite}
\def\pciteauthoryear{\def\bibauthoryear##1##2{(##1, ##2)}\cite}

\def\@cite#1#2{{#1\if@tempswa , #2\fi}}
\def\@citex[#1]#2{\leavevmode
  \let\@citea\@empty
  \@cite{\@for\@citeb:=#2\do
    {\@citea\def\@citea{,\penalty\@m\ }%
     \edef\@citeb{\expandafter\@firstofone\@citeb\@empty}%
     \if@filesw\immediate\write\@auxout{\string\citation{\@citeb}}\fi
     \@ifundefined{b@\@citeb}{\hbox{\reset@font\bfseries ?}%
       \G@refundefinedtrue
       \@latex@warning
         {Citation `\@citeb' on page \thepage \space undefined}}%
       {\csname b@\@citeb\endcsname}% \@cite@ofmt{}
     }}{#1}}

\renewcommand\footnoterule{%
  \kern-3\p@
  \hrule \@width 115pt %%\@width.4\columnwidth
  \kern2.6\p@}

\def\thefootnote{\fnsymbol{footnote}}%
\long\def\@makefntext#1{%
 \leftskip16pt
 \advance \mathindent 16pt
 \@totalleftmargin16pt
 \@tempdima\columnwidth
 \advance \@tempdima -16pt
 \linewidth\@tempdima
 \parindent16pt
 \save@parindent\parindent
 \noindent
 \hbox to \z@{\hss\hbox to 16pt{$^{\@thefnmark}$\hss}}%
 #1}%

%\def\@fnsymbol#1{\ensuremath{\ifcase#1\or *\or \dagger\or \ddagger\or
%   \mathsection\or \mathparagraph\or \|\or **\or \dagger\dagger
%   \or \ddagger\ddagger \else\@ctrerr\fi}}

%%   /usr/local/teTeX/share/texmf-dist/tex/latex/base/fleqn.clo
%\ProvidesFile{fleqn.clo}
%        [1998/08/17 v1.1c Standard LaTeX option
%                                   (flush left equations)]
\newdimen\mathindent
\AtEndOfClass{\mathindent10pt}%
\renewcommand\[{\relax
                \ifmmode\@badmath
                \else
                  \@InListEnv
                  \begin{trivlist}%
                    \@beginparpenalty\predisplaypenalty
                    \@endparpenalty\postdisplaypenalty
                    \item[]\leavevmode
                    \hb@xt@\linewidth\bgroup $\m@th\displaystyle %$
                      \hskip\mathindent\bgroup
                \fi}
\renewcommand\]{\relax
                \ifmmode
                      \egroup $\hfil% $
                    \egroup
                  \end{trivlist}%
                \else \@badmath
                \fi}
\renewenvironment{equation}%
    {\@beginparpenalty\predisplaypenalty
     \@endparpenalty\postdisplaypenalty
     \refstepcounter{equation}%
     \@InListEnv
     \trivlist \item[]\leavevmode
       \hb@xt@\linewidth\bgroup $\m@th% $
         \displaystyle
         \hskip\mathindent}%
        {$\hfil % $
         \displaywidth\linewidth\hbox{\@eqnnum}%
       \egroup
     \endtrivlist}
\renewenvironment{eqnarray}{%
    \stepcounter{equation}%
    \def\@currentlabel{\p@equation\theequation}%
    \global\@eqnswtrue\m@th
    \global\@eqcnt\z@
    \tabskip\mathindent
    \let\\=\@eqncr
    \@InListEnv
    \setlength\abovedisplayskip{\topsep}%
    \ifvmode
      \addtolength\abovedisplayskip{\partopsep}%
    \fi
    \addtolength\abovedisplayskip{\parskip}%
    \setlength\belowdisplayskip{\abovedisplayskip}%
    \setlength\belowdisplayshortskip{\abovedisplayskip}%
    \setlength\abovedisplayshortskip{\abovedisplayskip}%
    $$\everycr{}\halign to\linewidth% $$
    \bgroup
      \hskip\@centering
      $\displaystyle\tabskip\z@skip{##}$\@eqnsel&%
      \global\@eqcnt\@ne \hskip.8\arraycolsep \hfil${##}$\hfil&%
      \global\@eqcnt\tw@ \hskip.8\arraycolsep
        $\displaystyle{##}$\hfil \tabskip\@centering&%
      \global\@eqcnt\thr@@
        \hb@xt@\z@\bgroup\hss##\egroup\tabskip\z@skip\cr}%
      {\@@eqncr
    \egroup
    \global\advance\c@equation\m@ne$$% $$
    \@ignoretrue
    }

\def\@InListEnv{%
 \ifdim\topsep=\z@
  \@listi
 \fi
}
%%\endinput
%%
%% End of file `fleqn.clo'.

%\newcommand\contentsname{Contents}
%\newcommand\listfigurename{List of Figures}
%\newcommand\listtablename{List of Tables}
\newcommand\refname{Literature Cited}
%\newcommand\indexname{Index}
\newcommand\figurename{Fig.}
\newcommand\tablename{Table}
%\newcommand\partname{Part}
\newcommand\appendixname{Appendix}
%\newcommand\abstractname{Abstract}

\def\@begintheorem#1#2{%
 \topsep\z@\parsep\z@\itemsep\z@\partopsep\z@
 \labelsep1em
 \trivlist
   \item[\hskip \labelsep{\bfseries #1\ #2}]\itshape}
\def\@opargbegintheorem#1#2#3{%
 \topsep\z@\parsep\z@\itemsep\z@\partopsep\z@
 \labelsep1em
 \trivlist
   \item[\hskip \labelsep{\bfseries #1\ #2\ (#3)}]\itshape}
\def\@endtheorem{\endtrivlist}

\def\today{\ifcase\month\or
  January\or February\or March\or April\or May\or June\or
  July\or August\or September\or October\or November\or December\fi
  \space\number\day, \number\year}

\setlength\columnsep{24\p@}
\setlength\columnseprule{0\p@}

%%<local>
\def\Hline{\noalign{\hrule \@height 1pt}}

\def\onelineskip{\par\vspace{1\baselineskip}\par}
\def\halflineskip{\par\vspace{.5\baselineskip}\par}

\def\lastpagebalanced#1{%
 \begin{figure}[b]
 \vspace{#1}
 \end{figure}
}

\def\QED{{\unskip\nobreak\hfil\penalty50
 \hskip1em\hbox{}\nobreak\hfil \hbox{$\Box$\hskip1em}
 \parfillskip\z@ \finalhyphendemerits\z@\par}}

\def\figref{\@RefName{Figure}}
\def\tabref{\@RefName{Table}}

\def\@RefName#1{\gdef\R@t{#1}\gdef\@RefType{#1~}\gdef\@RefTypes{#1s~}%
 \@Reffloat}% 
\def\@RefType{}
\def\@RefTypes{}

%% borrowed from citesort.sty
\newcount\@minsofar
\newcount\@min
\newcount\@Float@temp
\newcount\@tempcntc
\newcount\@holdrefnum

\def\@Reffloat#1{%
 \leavevmode
 \@tempcnta\z@
 \@tempcntc\z@
 \@holdrefnum\z@
 \@for\count@Float:=#1\do{%
  \global\advance \@tempcnta \@ne
  \global\advance \@holdrefnum \@ne
  \@ifundefined{bf@\count@Float}%
   {\expandafter\def\csname bf@\count@Float\endcsname{}%
    \let\@BorR\bfseries}%
   {\let\@BorR\relax}%
 }%
 \ifnum \@tempcnta > \@ne
  {\@BorR \@RefTypes}%
 \else
  {\@BorR \@RefType}%
 \fi
 %%
 \@tempcntb\m@ne \let\@h@ld\relax \def\@Floata{}%
 \@min\m@ne
 \@for\@Float:=#1\do{%
  \global\advance \@tempcntc \@ne
  \@ifundefined{r@\@Float}{\@tempcntb\m@ne{\bfseries ?}}%
  {\@minsofar\z@ \@for\@scan@Floats:=#1\do{%
   \@ifundefined{r@\@scan@Floats}{\@Float@temp\m@ne}%
    {\edef\@tempa{\@nameuse{r@\@scan@Floats}}%
      \edef\num@Float{\expandafter\@car\@tempa \@nil}% \null
      \@Float@temp\num@Float \relax}%
    \ifnum\@Float@temp > \@min
     \ifnum\@minsofar = \z@
       \@minsofar\number\@Float@temp
       \edef\@scan@copy{\@scan@Floats}% 
     \else
      \ifnum\@Float@temp < \@minsofar
       \@minsofar\number\@Float@temp
       \edef\@scan@copy{\@scan@Floats}%
      \fi
     \fi
    \fi}%
   \@tempcnta\@min
   \ifnum\@minsofar > \z@
    \advance\@tempcnta\@ne
    \@min\@minsofar
     \ifnum\@tempcnta=\@minsofar
      \ifx\@h@ld\relax
       \edef\@tempa{\@nameuse{r@\@scan@copy}}%
	\edef\num@Float{\expandafter\@car\@tempa \@nil}% \null
	 \@ifundefined{Float@\R@t\num@Float}%
	  {\expandafter\gdef\csname Float@\R@t\num@Float\endcsname{}%
	 \let\oldnum@Float=\num@Float
	 \def\num@Float{{\noexpand\bfseries \oldnum@Float}}}{\relax}%
	 \edef\@h@ld{\@Floata\num@Float}%
      \else
       \edef\@tempa{\@nameuse{r@\@scan@copy}}%
	\edef\num@Float{\expandafter\@car\@tempa \@nil}% \null
	 \@ifundefined{Float@\R@t\num@Float}% 
	  {\expandafter\gdef\csname Float@\R@t\num@Float\endcsname{}%
	 \let\oldnum@Float=\num@Float
	 \def\num@Float{{\noexpand\bfseries \oldnum@Float}}}{\relax}%
	 \edef\@h@ld{--\num@Float}% 
      \fi
     \else
      \edef\@tempa{\@nameuse{r@\@scan@copy}}%
       \edef\num@Float{\expandafter\@car\@tempa \@nil}% \null
	\@ifundefined{Float@\R@t\num@Float}%
	 {\expandafter\gdef\csname Float@\R@t\num@Float\endcsname{}%
	\let\oldnum@Float=\num@Float%
	\edef\num@Float{{\noexpand\bfseries \oldnum@Float}}}{\relax}%
	\@h@ld\@Floata\num@Float%
      \let\@h@ld\relax
     \fi
   \fi
  }%
  \def\@Floata{\ifnum\@tempcntc<\@holdrefnum , \else\ and \fi}%
 }%
 \@h@ld}
%%</local>

\def\sloppy{\tolerance9999\hbadness9999\hfuzz.5\p@ \vfuzz.5\p@}

\hbadness4000
\vbadness10001
\tolerance4000\pretolerance\m@ne
\clubpenalty\z@
\widowpenalty\z@

\AtBeginDocument{%
 \label{jcej@firstpage}%
 %%
 \displaywidowpenalty\z@
 \interdisplaylinepenalty\z@
 \predisplaypenalty\z@
 \postdisplaypenalty\z@
 %% ams fleqn
 \@ifundefined{maketag@@@}{}{%
   %\let\@mathmargin\mathindent
   \@mathmargin10pt \@plus\z@ \@minus\z@
   \multlinegap10pt
 }%
 %% nidanfloat
 \@ifundefined{dblbotfraction}{}{%
  \renewcommand\dblbotfraction{0.9}% 0.5
  \setcounter{dblbotnumber}{4}% 2
 }%
 %% here.sty
 \@ifundefined{@HHfloat}{}{%
  \def\@HHfloat#1[H]{%
   \expandafter\let\csname end#1\endcsname\end@Hfloat
   \vskip\intextsep
   \vbox\bgroup\def\@captype{#1}\parindent\z@
   \@floatboxreset %% added
   \ignorespaces}%
  \def\end@Hfloat{\egroup\vskip-1em %% added
   \vskip \intextsep}%
 }%
 %% soul.sty
 \@ifundefined{SOUL@}{%
  \let\ul\relax
  \jcej@warning{jcej.cls requires "soul" package 
   to underline \string\subsubsection}%
  }{%
  \setul{.15ex}{.3pt}% \setul{.65ex}{.1ex}
 }%
}

\AtEndDocument{%
 \clearpage
 \addtocounter{page}{-1}%
 \immediate\write\@auxout
  {\string\newlabel{jcej@lastpage}{{}{\thepage}}}%
 %\addtocounter{page}{1}%
}

\pagestyle{jcej}
\pagenumbering{arabic}
\if@twoside
\else
 \raggedbottom
\fi
\if@twocolumn
  \twocolumn
  \sloppy
  \flushbottom
\else
  \onecolumn
\fi

\endinput
